/*
 * @cmnStruct.java Version 1.1 06/26/2006
 *
 * Copyright (c) 2006 Kansas Geological Survey
 * 1930 Constant Avenue, Lawrence, Kansas, 66047, U.S.A.
 * All Rights Reserved.
 */

package cmn;

import java.net.*;
import java.awt.*;
import java.applet.*;
import javax.swing.*;

//import kgs.kgsUserStruct;

/** CLASS cmnStruct
 *  <p> This Class holds the global gui data structure data.
 *      NOTE: This version is designed for the LASFileReader and will not work
 *            with other web apps.
 *  @version 1.1 06/26/2006
 *  @author  John R. Victorine
 *  @modified 07/12/2007 for LAS File Reader
 */

public class cmnStruct
{
  // Kansas Geological Survey Home Web Addresses

  public static final String KGS      = "http://www.kgs.ku.edu";
  public static final String CO2      = "http://www.kgs.ku.edu/PRS/Ozark/";
  public static final String STRAT    = "http://www.kgs.ku.edu/stratigraphic/";

//  public static final String ABYSS    = "http://abyss.kgs.ku.edu";

  /* ======================================================================= *
   * ------------ Web Applications XML Mnemonics & ICON IMAGES ------------- *
   * ======================================================================= */

  public static final String GEMINI = "http://www.kgs.ku.edu/software/gemini";
  public static final String DATA   = GEMINI + "/data";
  public static final String IMAGES = GEMINI + "/images";

  // DOE CO2 LAS 3.0 Files URL Path

  public static final String DOE_CO2      = "http://www.kgs.ku.edu/PRS/Ozark/";
  public static final String DOE_CO2_DATA = DOE_CO2 + "GXSection/data/";
  public static final String DOE_CO2_LAS3 = DOE_CO2 + "file_data/LAS3/";

  // .. KGS LAS Standard Tools Thesaurus XML Files

  public static final String TOOLS_HIERARCHY_XML    = DATA + "/tools_hierarchy.xml";
  public static final String LAS_STANDARD_TOOLS_XML = DATA + "/las_standard_tools.xml";

  // .. Well Symbol Thesaurus XML Files

  public static final String WELL_SYMBOLS_XML       = DATA + "/WellSymbols.xml";

  /* ======================================================================= *
   * --------------------- Web Applications Mnemonics ---------------------- *
   * ======================================================================= */

  // BASE URL to the ABYSS PLSQL Stored procedure base path.

  public static final String PLSQL       = "http://chasm.kgs.ku.edu/ords/";
  public static final String PLSQL_USER  = "http://chasm.kgs.ku.edu/ords/iqstrat.";

  // BASE DIRECTORY of IQSTRAT

  public static final String IQSTRAT_BASE = STRAT + "IQSTRAT/";

  // User Login

  public static final String  KGS_USER = PLSQL_USER + "iqstrat.iqstrat_users_pkg.getXML?";

  // Headers Information URL's

//  public static final String  KGS_HEADERS_READ_LIST = PLSQL_USER + "user_headers_pkg.getXML?";
//  public static final String  KGS_HEADERS_READ      = PLSQL_USER + "headers_pkg.getXML?";
//  public static final String  KGS_HEADERS_WRITE     = PLSQL_USER + "headers_pkg.saveXML?";
  public static final String  KGS_WELL_HEADERS_READ = PLSQL_USER + "kgs_well_headers_pkg.getXML?";

  // LAS Files XML - Input: API-Number of Well (sAPI)

  public static final String KGS_LAS_FILES = PLSQL_USER + "kgs_las_files_pkg.getXML?";

  // LAS File Curves XML - Input: API-Number of Well (sLASKID)

  public static final String KGS_LAS_FILE_CURVES = PLSQL_USER + "kgs_las_curves_pkg.getXML?";

  // DST & Perforations XML - Input: API-Number of Well (sAPI)

  public static final String KGS_DST_PERFS = PLSQL_USER + "kgs_perfs_dst_pkg.getXML?";

  // Latitude & Longitude from TRS

  public static final String KGS_TRS2LL = PLSQL_USER + "TRS2LL_pkg.getXML?";

  /* ======================================================================= *
   * ----------------------------- TRACK Icons ----------------------------- *
   * ======================================================================= */

  public static final String      ALL_TRACKS   = "/images/all.png";
  public static final String      LAS_TRACKS   = "/images/las.png";
  public static final String      ROCK_TRACKS  = "/images/rock.png";
  public static final String      TOPS_TRACKS  = "/images/horizon.png";
  public static final String      Pf_TRACKS    = "/images/Pf.png";
  public static final String      GEO_TRACKS   = "/images/geo.png";

  /* ======================================================================= *
   * ------------------------------ EDIT Icons ----------------------------- *
   * ======================================================================= */

  public static final String      OPEN     = "/images/select.png";
  public static final String      NEW      = "/images/new.png";
  public static final String      MODIFY   = "/images/modify.png";
  public static final String      DELETE   = "/images/remove.png";
  public static final String      SAVE     = "/images/save.png";
  public static final String      CSV      = "/images/save_csv.png";
  public static final String      PDF      = "/images/save_pdf.png";
  public static final String      CLOSE    = "/images/close.png";

  /* ======================================================================= *
   * ---------------------------- KGS Logo Icon ---------------------------- *
   * ======================================================================= */

  public static final String      ICON   = "images/kgsSm.png";
  public static final String      ICON2  = "images/kgsSm2.png";

  /* ======================================================================= *
   * ----------------------------- Image Icons ----------------------------- *
   * ======================================================================= */

  public static final int    _LAS        = 2; // LAS File Data Entry & Viewer

  public static final String WEB_APP     = "/images/logdataLg.png";
  public static final String SEISMIC_APP = "/images/waves.png";
  public static final String WAVE_ICON   = "/images/wave_icon.png";

  public static final String WELL_DATA   = "/images/WellData.png";
  public static final String LAS_FILE    = "/images/las-file.png";

  /* ======================================================================= *
   * ------------------------------ Constants ------------------------------ *
   * ======================================================================= */

  public static final int _NO    = 0;
  public static final int _YES   = 1;

  public static final int OFF    = 0;
  public static final int ON     = 1;

  public static final int ALL    = 0;
  public static final int SELECT = 1;
  public static final int NONE   = 2;

  /* ======================================================================= *
   * --------------------------- Global Variables -------------------------- *
   * ======================================================================= */

  public int           iServerUsed;     // Server that will be used.
  public boolean       bStandalone;     // Application is Stand alone
  public URL           urlDirCodeBase;  // Base URL of Applet.
  public AppletContext appletContext;   // Applet Context
  public String        sPath;           // Path to retrieve data from JAR File
  public String        sImagePath;      // Path to retrieve images from JAR File
  public String        sGEMINI;         // Path to the GEMINI Data Directory work space
  public ClassLoader   cl;
  public Image         pIcon  = null;
  public Image         pIcon2 = null;
}