/*
 * @lasPlotFilterListStruct.java Version 1.1 11/05/2015
 *
 * Copyright (c) 2015 Kansas Geological Survey
 * 1930 Constant Avenue, Lawrence, Kansas, 66047, U.S.A.
 * All Rights Reserved.
 */

package las;

import las.lasPlotFilterStruct;

/** Class lasPlotFilterListStruct
 *  <p> This class will hold the list of filter ranges
 *
 *  @version 1.1 11/05/2015
 *  @author  John R. Victorine
 */

public class lasPlotFilterListStruct
{
  public int                iCount   = 0;    // Total Number of Records
  public lasPlotFilterStruct stItem[] = null; // Total Filter By Data

  /** Method delete()
   * <p> This method will set the arrays to null in order to get Java to
   *     deallocate memory for the object.
   */

  public void delete()
  {
    for (int i=0; i<iCount; i++)
    {
      if (stItem[i] != null)
        stItem[i].delete();
      stItem[i] = null;
    }

    iCount = 0;
  }
}

/*
 *  @version 1.1 11/05/2015
 *  @author  John Victorine
 */
