/*
 * @lasPlotFilterUtility.java Version 1.1 11/05/2015
 *
 * Copyright (c) 2015 Kansas Geological Survey
 * 1930 Constant Avenue, Lawrence, Kansas, 66047, U.S.A.
 * All Rights Reserved.
 */

package las;

import las.lasPlotFilterStruct;
import las.lasPlotFilterListStruct;

/** Class lasPlotFilterUtility
 *  <p> This class will hold the Constants for the data plot classes
 *
 *  @version 1.1 11/05/2015
 *  @author  John R. Victorine
 */

public class lasPlotFilterUtility
{
  // -------------------------------------------------------
  // Filter possible symobls & colors
  // -------------------------------------------------------

  // Symbols Types

  public static final int OVAL      = plot.plotSymbolStruct.OVAL;
  public static final int RECTANGLE = plot.plotSymbolStruct.RECTANGLE;
  public static final int TRIANGLE  = plot.plotSymbolStruct.TRIANGLE;
  public static final int DIAMOND   = plot.plotSymbolStruct.DIAMOND;
  public static final int DELTA     = plot.plotSymbolStruct.DELTA;
  public static final int MAXIMUM   = 5;

  // Colors
/*
  public static final int _RED             =  0; // "red"

  public static final int _BROWN           =  1; // "brown"
  public static final int _SIENNA          =  2; // "sienna"
  public static final int _BURLYWOOD       =  3; // "burlywood"
  public static final int _TAN             =  4; // "tan"

  public static final int _SALMON          =  5; // "salmon"
  public static final int _ORANGE_RED_1    =  6; // "orange red 1"
  public static final int _DARK_ORANGE     =  7; // "dark orange"
  public static final int _ORANGE          =  8; // "orange"

  public static final int _MIDDLE_YELLOW   =  9; // "middle yellow"
  public static final int _DARKER_YELLOW   = 10; // "darker yellow"
  public static final int _YELLOW          = 11; // "yellow"

  public static final int _GREEN_YELLOW    = 12; // "green yellow"
  public static final int _YELLOW_GREEN    = 13; // "yellow green"
  public static final int _PALE_GREEN      = 14; // "pale green 1"
  public static final int _LIGHT_GREEN     = 15; // "light green"
  public static final int _GREEN           = 16; // "green"
  public static final int _LAWN_GREEN      = 17; // "lawn green"
  public static final int _FOREST_GREEN    = 18; // "forest green"
  public static final int _OLIVE_DRAB      = 19; // "olive drab"

  public static final int _TURQUOISE       = 20; // "turquoise"
  public static final int _AQUAMARINE_1    = 21; // "aquamarine 1"
  public static final int _AQUAMARINE_3    = 22; // "aquamarine 3"
  public static final int _AQUAMARINE_4    = 23; // "aquamarine 4"
  public static final int _MIDDLE_CYAN     = 24; // "middle cyan"
  public static final int _CYAN            = 25; // "cyan"

  public static final int _SKY_BLUE        = 26; // "sky blue"
  public static final int _DEEP_SKY_BLUE_1 = 27; // "deep sky blue 1"
  public static final int _DEEP_SKY_BLUE_2 = 28; // "deep sky blue 2"
  public static final int _MIDDLE_BLUE     = 29; // "middle blue"
  public static final int _ROYAL_BLUE      = 30; // "royal blue"
  public static final int _BLUE            = 31; // "blue"

  public static final int _LIGHT_PINK      = 32; // "light pink"
  public static final int _HOT_PINK        = 33; // "hot pink"
  public static final int _DEEP_PINK       = 34; // "deep pink"

  public static final int _LIGHT_MAGENTA   = 35; // "light magenta"
  public static final int _MAGENTA         = 36; // "magenta"
  public static final int _VIOLET          = 37; // "violet"
  public static final int _DARK_VIOLET     = 38; // "dark violet"

  public static final int _GREY_90         = 39; // "grey 90"
  public static final int _GREY            = 40; // "grey"
  public static final int _GREY_50         = 41; // "grey 50"
  public static final int _BLACK           = 42; // "black"
*/
  public static final int TOTAL            = las.lasPlotConstants._GREY_90;
  public static final int COLORS[][]       = las.lasPlotConstants.COLORS;

  public static final int    _TOTAL = 13;
  public static final double _RATIO[][] = {
    { 0.0,  0.89, 255, 255, 102 },   // < 0.89          2
    { 0.89, 0.91, 255, 255,   0 },   // 0.89 - 0.91     4
    { 0.91, 0.93, 255, 204,  51 },   // 0.91 - 0.93     6
    { 0.93, 0.95, 255, 153,  51 },   // 0.93 - 0.95     8
    { 0.95, 0.97, 204, 102,   0 },   // 0.95 - 0.97    10
    { 0.97, 0.99, 153,  51,   0 },   // 0.97 - 0.99    12
    { 0.99, 1.01,   0,   0,   0 },   // 0.99 - 1.01
    { 1.01, 1.03,  51, 102, 204 },   // 1.01 - 1.03    12
    { 1.03, 1.05,   0, 153, 255 },   // 1.03 - 1.05    10
    { 1.05, 1.07,   0, 204, 255 },   // 1.05 - 1.07     8
    { 1.07, 1.09,  51, 204, 153 },   // 1.07 - 1.09     7
    { 1.09, 1.11,   0, 255, 153 },   // 1.09 - 1.11     6
    { 1.11, 5.0,   51, 255,  51 },   // > 1.11          4
  };

  public static final String RATIO[] = {
    "< 0.89",
    "0.89 - 0.91",
    "0.91 - 0.93",
    "0.93 - 0.95",
    "0.95 - 0.97",
    "0.97 - 0.99",
    "0.99 - 1.01",
    "1.01 - 1.03",
    "1.03 - 1.05",
    "1.05 - 1.07",
    "1.07 - 1.09",
    "1.09 - 1.11",
    "> 1.11"
  };

/*
  public static final int _MMHOS_M  = 16;
  public static final int MMHOS_M[][] =
  { {255, 255, 204},
    {255, 255, 102},     2
    {255, 255,  51},
    {255, 255,   0},     4
    {255, 204, 102},
    {255, 204,  51},     6
    {255, 204,   0},
    {255, 153,  51},     8
    {255, 153,   0},
    {204, 102,   0},    10
    {204, 102,  51},
    {153,  51,   0},    12
    {153,  51,  51},
    {102,  51,   0},    14
    {102,  51,  51},
    { 51,   0,   0} };  16

  public static final int _PU  = 16;
  public static final int PU[][] =
  { {204, 255, 204},
    {153, 255, 153},     2
    {102, 255, 102},
    { 51, 255,  51},     4
    {  0, 255,   0},
    {  0, 255, 153},     6
    { 51, 204, 153},
    {  0, 204, 255},     8
    { 51, 153, 255},
    {  0, 153, 255},    10
    {  0, 102, 204},
    { 51, 102, 204},    12
    {102, 102, 204},
    {102,  51, 204},    14
    {102,  51, 102},
    { 51,   0,  51}};   16
*/

  /** Method getFilter()
   *  <p> This method will retrieve a default filter list
   */

  public static lasPlotFilterListStruct getFilter()
  {
	int    MAX      = 0;
	double DATA[][] = null;
	String NAME[]   = null;

	lasPlotFilterStruct     stFilter = null;
	lasPlotFilterListStruct st = new lasPlotFilterListStruct();

    MAX  = _TOTAL;
    DATA = _RATIO;
    NAME = RATIO;

    if ((DATA != null) && (NAME != null))
    {
	  for (int i=0; i<MAX; i++)
	  {
		stFilter           = new lasPlotFilterStruct();
		stFilter.sKEY      = new String( cmn.cmnString.UniqueName() + "_" + i );
		stFilter.iBy       = las.lasPlotFilterStruct._BY_DATA;
        stFilter.dataStart = DATA[i][0]; // Starting Data
        stFilter.dataEnd   = DATA[i][1];   // Ending Data

        // Symbol and Color

        stFilter.iEmpty  = 1;      // Open or Filled Symbol
        stFilter.iSymbol = DIAMOND;
        stFilter.iRed    = (int) DATA[i][2]; // Red Color in RGB Setting
        stFilter.iGreen  = (int) DATA[i][3]; // Green Color in RGB Setting
        stFilter.iBlue   = (int) DATA[i][4]; // Blue Color in RGB Setting
        stFilter.symbol  = new String(NAME[i]);  // Label for the selected symbol.

	    st = add( stFilter, st );
	  }
	}

	return (st);
  }

  /** Method getFilter()
   *  <p> This method will retrieve a default filter list
   *  @param  dStart   = starting depth
   *  @param  dEnd     = ending depth
   *  @param  iColors  = total number of colors to use
   *  @return stFilter = The Plot Filter List Structure
   */

  public static lasPlotFilterListStruct getFilter(double dStart, double dEnd, int iColors)
  {
	lasPlotFilterStruct     stFilter = null;
	lasPlotFilterListStruct st = new lasPlotFilterListStruct();
    int i1    = 0;
    int i2    = 0;
    int indx  = 1+((int)dEnd - (int)dStart) / iColors;

	for (int i=0; i<iColors; i++)
	{
	  i1 = (int) dStart + i*indx;
	  i2 = (int) dStart + (i+1)*indx;

	  stFilter           = new lasPlotFilterStruct();
	  stFilter.sKEY      = new String( cmn.cmnString.UniqueName() + "_" + i );
	  stFilter.iBy       = las.lasPlotFilterStruct._BY_DEPTH;
      stFilter.depthStart = dStart; // Starting Data
      stFilter.depthEnd   = dEnd;   // Ending Data

      // Symbol and Color

      stFilter.iEmpty  = 1;      // Open or Filled Symbol
      stFilter.iSymbol = DIAMOND;
      stFilter.iRed    = (int) COLORS[i][0]; // Red Color in RGB Setting
      stFilter.iGreen  = (int) COLORS[i][1]; // Green Color in RGB Setting
      stFilter.iBlue   = (int) COLORS[i][2]; // Blue Color in RGB Setting
      stFilter.symbol  = new String("" + i1 + "' to " + i2 + "'");  // Label for the selected symbol.

	  st = add( stFilter, st );
	}

	return (st);
  }

  /** Method getFilter()
   *  <p> This method will retrieve a default filter list
   *  @param  dStart   = starting depth
   *  @param  dEnd     = ending depth
   *  @param  iColors  = total number of colors to use
   *  @return stFilter = The Plot Filter List Structure
   */

  public static int getFilter(double depth, double dStart, double dEnd, int iColors)
  {
	int iFilter = 999;
    int i1      = 0;
    int i2      = 0;
    int indx    = 1+((int)dEnd - (int)dStart) / iColors;

	for (int i=0; i<iColors; i++)
	{
	  i1 = (int) dStart + i*indx;
	  i2 = (int) dStart + (i+1)*indx;

	  if (((int) depth >= i1) && ((int) depth < i2))
	    iFilter = i;
    }

	return (iFilter);
  }

  /** Method copyList()
   * <p> This method will copy one structure to another
   * @param  stOld = the Old List Structure
   * @return stNew = the New List structure
   */

  public static lasPlotFilterListStruct copyList( lasPlotFilterListStruct stOld )
  {
    lasPlotFilterListStruct stNew = null;

    if (stOld != null)
    {
      stNew            = new lasPlotFilterListStruct();
      stNew.iCount     = stOld.iCount;
      stNew.stItem     = new lasPlotFilterStruct[stOld.iCount];

      for (int i=0; i<stOld.iCount; i++)
      {
        stNew.stItem[i] = copy( stOld.stItem[i] );
      }
    }

    return (stNew);
  }

  /** Method copy()
   * <p> This method will copy the data structure
   * @param  stOld = The old data structure
   * @return stNew = The new data structure
   */

  public static lasPlotFilterStruct copy( lasPlotFilterStruct stOld )
  {
    lasPlotFilterStruct stNew = new lasPlotFilterStruct();

    if (stOld != null)
    {
      stNew.iBy        = stOld.iBy;                 // Filter By Indicator

      stNew.sKEY       = new String(stOld.sKEY);    // Primary Key

      stNew.depthStart = stOld.depthStart;          // Starting Depth
      stNew.depthEnd   = stOld.depthEnd;            // Ending Depth

      stNew.dataStart  = stOld.dataStart;           // Starting Data Value
      stNew.dataEnd    = stOld.dataEnd;             // Ending Data Value

      // Symbol and Color

      stNew.iEmpty     = stOld.iEmpty;              // Open or Filled Symbol
      stNew.iSymbol    = stOld.iSymbol;             // Symbol Identifier.
      stNew.iRed       = stOld.iRed;                // Red Color in RGB Setting
      stNew.iGreen     = stOld.iGreen;              // Green Color in RGB Setting
      stNew.iBlue      = stOld.iBlue;               // Blue Color in RGB Setting
      stNew.symbol     = new String(stOld.symbol);  // Label for the selected symbol.
    }

    return (stNew);
  }

  /** Method add()
   * <p> This method will add the data to the list
   * @param  stBlock = the New Data Structure
   * @param  st      = the List Structure
   * @return st      = the Modified List structure
   */

  public static lasPlotFilterListStruct add(
	  lasPlotFilterStruct     stBlock,
	  lasPlotFilterListStruct st )
  {
	int i = 0;
	int iCount = 0;
    lasPlotFilterListStruct stTemp = new lasPlotFilterListStruct();

    stTemp.iCount = 1;
    stTemp.stItem = new lasPlotFilterStruct[1];

    if (st != null)
    {
      stTemp.stItem = new lasPlotFilterStruct[st.iCount+1];

      for (i=0; i<st.iCount; i++)
      {
        stTemp.stItem[iCount] = copy( st.stItem[i] );
        iCount++;
      }

      st.delete();
      st = null;
    }

    stTemp.stItem[iCount] = copy( stBlock );
    iCount++;

    st        = new lasPlotFilterListStruct();
    st.stItem = new lasPlotFilterStruct[iCount];
    st.iCount = iCount;

    for (i=0; i<iCount; i++)
    {
      st.stItem[i] = copy( stTemp.stItem[i] );
    }

    stTemp.delete();
    stTemp = null;

    return (st);
  }

  /** Method modify()
   * <p> This method will modify data within the list
   * @param  stBlock = the New Data Structure
   * @param  st      = the List Structure
   * @return st      = the Modified List structure
   */

  public static lasPlotFilterListStruct modify(
	  lasPlotFilterStruct     stBlock,
	  lasPlotFilterListStruct st )
  {
	int i = 0;
	int iCount = 0;
    lasPlotFilterListStruct stTemp = new lasPlotFilterListStruct();

    if (st != null)
    {
      stTemp.stItem = new lasPlotFilterStruct[st.iCount];

      for (i=0; i<st.iCount; i++)
      {
		if (!st.stItem[i].sKEY.equals(stBlock.sKEY))
          stTemp.stItem[iCount] = copy( st.stItem[i] );
        else
          stTemp.stItem[iCount] = copy( stBlock );

        iCount++;
      }

      st.delete();
      st = null;

      st        = new lasPlotFilterListStruct();
      st.stItem = new lasPlotFilterStruct[iCount];
      st.iCount = iCount;

      for (i=0; i<iCount; i++)
      {
        st.stItem[i] = copy( stTemp.stItem[i] );
      }

      stTemp.delete();
      stTemp = null;
    }

    return (st);
  }

  /** Method remove()
   * <p> This method will remove the data from the list
   *     This method assumes that the data structure that
   *     is to be removed exists in the list.
   * @param  stBlock = the New Data Structure
   * @param  st      = the List Structure
   * @return st      = the Modified List structure
   */

  public static lasPlotFilterListStruct remove(
	  String                   sKEY,
	  lasPlotFilterListStruct st )
  {
	int i = 0;
	int iCount = 0;
    lasPlotFilterListStruct stTemp = null;

    if (st != null)
    {
	  if (st.iCount > 1)
	  {
	    stTemp        = new lasPlotFilterListStruct();
        stTemp.stItem = new lasPlotFilterStruct[st.iCount-1];

        for (i=0; i<st.iCount; i++)
        {
  		  if (!sKEY.equals(st.stItem[i].sKEY))
  		  {
            stTemp.stItem[iCount] = copy( st.stItem[i] );
            iCount++;
	      }
        }

        st.delete();
        st = null;

        st        = new lasPlotFilterListStruct();
        st.stItem = new lasPlotFilterStruct[iCount];
        st.iCount = iCount;

        for (i=0; i<iCount; i++)
        {
          st.stItem[i] = copy( stTemp.stItem[i] );
        }

        stTemp.delete();
        stTemp = null;
      }
      else
      {
	    st.delete();
	    st = null;
	  }
    }

    return (st);
  }

  /** Method print()
   *  <p> This method print the contents of List Structure
   *  @param  st      = the List Structure
   */

  public static void print(lasPlotFilterListStruct st)
  {
    if (st != null)
    {
	  for (int i=0; i<st.iCount; i++)
	  {
		System.out.println(
			st.stItem[i].iBy +
		    "KEY=" + st.stItem[i].sKEY          + " " +
		    "Depth: " + st.stItem[i].depthStart + "-" +
		                st.stItem[i].depthEnd   + " " +
		    "Data: "  + st.stItem[i].dataStart  + "-" +
		                st.stItem[i].dataEnd    + " " +
		    "Symbol=" +
		      plot.plotSymbolStruct.SHAPE_EMPTY[st.stItem[i].iSymbol] + " " +
		    "RGB="    + st.stItem[i].iRed   + " " +
		                st.stItem[i].iGreen + " " +
		                st.stItem[i].iBlue  + " " +
		    "Legend=" + st.stItem[i].symbol );
      }
    }
  }
}

/*
 *  @version 1.1 11/05/2015
 *  @author  John Victorine
 */
